=== debian/changelog ===
falcosecurity-libs (0.18.1-2ubuntu4) plucky; urgency=medium

  * No-change rebuild for libjsoncpp26

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Sun, 10 Nov 2024 10:47:27 +0000

falcosecurity-libs (0.18.1-2ubuntu3) plucky; urgency=medium

  * Back in sync w Debian

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 30 Oct 2024 22:32:22 +0100

falcosecurity-libs (0.18.1-2ubuntu2) plucky; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - disable LTO, fix FTBFS (fixes amd64 ftbfs)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 30 Oct 2024 22:31:31 +0100

falcosecurity-libs (0.18.1-2ubuntu1) plucky; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Ignore test failures on armhf/s390x (fixes armhf/s390x ftbfs)
    - disable LTO, fix FTBFS (fixes amd64 ftbfs)
    - Use liblua5.3-dev instead of liblua5.1-dev to fix ftbfs
      on riscv64 and ppc64el.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 30 Oct 2024 21:56:34 +0100

falcosecurity-libs (0.18.1-2) unstable; urgency=medium

  * Disabling i386 builds
    This has been broken upstream for a long time

 -- Dima Kogan <dkogan@debian.org>  Tue, 08 Oct 2024 21:45:03 -0700

falcosecurity-libs (0.18.1-1) unstable; urgency=medium

  * New upstream release

 -- Dima Kogan <dkogan@debian.org>  Tue, 01 Oct 2024 21:51:40 -0700

falcosecurity-libs (0.15.1-4ubuntu2) oracular; urgency=medium

  * debian/patches/fix-driver-fix-build-of-kmod-on-linux-6.10.patch
    - Linux 6.10: fix build of kmod (LP: #2071301)

 -- Guoqing Jiang <guoqing.jiang@canonical.com>  Mon, 29 Jul 2024 10:17:05 +0800

falcosecurity-libs (0.15.1-4ubuntu1) oracular; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - Ignore test failures on armhf/s390x (fixes armhf/s390x ftbfs)
    - disable LTO, fix FTBFS (fixes amd64 ftbfs)
    - Use liblua5.3-dev instead of liblua5.1-dev to fix ftbfs
      on riscv64 and ppc64el.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 27 May 2024 08:07:10 +0200

falcosecurity-libs (0.15.1-4) unstable; urgency=medium

  * Reverted the use-group-to-access-scap-device patches.
    Because they didn't work properly. (Reopens: #745706)
    (Closes: #1071622)

 -- Dima Kogan <dkogan@debian.org>  Fri, 24 May 2024 21:32:53 -0700

falcosecurity-libs (0.15.1-3ubuntu3) oracular; urgency=medium

  * Rebuild against new libre2-11.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 24 May 2024 19:35:10 +0200

falcosecurity-libs (0.15.1-3ubuntu2) oracular; urgency=medium

  * Rebuild against new libre11.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 24 May 2024 10:39:05 +0200

falcosecurity-libs (0.15.1-3ubuntu1) oracular; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - Ignore test failures on armhf/s390x (fixes armhf/s390x ftbfs)
    - disable LTO, fix FTBFS (fixes amd64 ftbfs)
    - Use liblua5.3-dev instead of liblua5.1-dev to fix ftbfs
      on riscv64 and ppc64el.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 20 May 2024 11:35:10 +0200

falcosecurity-libs (0.15.1-3) unstable; urgency=medium

  * scap driver now accessible as a non-root user, if they're in the
    "scap" group.
    Thanks to Gerald Combs <gerald@wireshark.org> (Closes: #745706)
  * debian/watch doesn't consider pre-release tags

 -- Dima Kogan <dkogan@debian.org>  Fri, 17 May 2024 22:41:31 -0700
