=== debian/control ===
Source: falcosecurity-libs
Section: libdevel
Priority: optional
Maintainer: Dima Kogan <dkogan@debian.org>
Build-Depends: dpkg-dev (>= 1.22.5),
               cmake,
               debhelper-compat (= 13),
               libvalijson-dev (>= 0.6),
               libb64-dev,
               libc-ares-dev,
               libcurl4-openssl-dev,
               libgrpc++-dev,
               libgrpc-dev,
               libgtest-dev,
               libjq-dev,
               libjsoncpp-dev,
               libprotobuf-dev,
               libssl-dev,
               libtbb-dev,
               zlib1g-dev,
               libjsoncpp-dev,
               protobuf-compiler,
               protobuf-compiler-grpc,
               libprotobuf-dev,
               libluajit-5.1-dev [amd64 arm64 armel armhf i386 mips64el s390x] | liblua5.1-0-dev,
               libelf-dev,
               libre2-dev,
               libcap-dev,
               uthash-dev,
               libabsl-dev
Build-Depends-Indep: dh-sequence-dkms
Testsuite: autopkgtest-pkg-dkms
Standards-Version: 4.6.0
Homepage: https://github.com/falcosecurity/libs
Vcs-Git: https://salsa.debian.org/debian/falcosecurity-libs.git
Vcs-Browser: https://salsa.debian.org/debian/falcosecurity-libs

Package: libfalcosecurity0t64
Provides: ${t64:Provides}
Replaces: libfalcosecurity0
Breaks: libfalcosecurity0 (<< ${source:Version})
Section: libs
# Disabling i386 builds for now; broken upstream. See: https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=1067619
Architecture: amd64 arm64 armel armhf mips64el ppc64el riscv64 s390x
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Core libraries for Falco and Sysdig
 Sysdig instruments your physical and virtual machines at the OS level
 by installing into the Linux kernel and capturing system calls and
 other OS events. Then, using sysdig's command line interface, you can
 filter and decode these events in order to extract useful information
 and statistics.
 .
 This package contains the run-time libraries to read the events from the
 driver.

Package: libfalcosecurity0-dev
Section: libdevel
# Disabling i386 builds for now; broken upstream. See: https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=1067619
Architecture: amd64 arm64 armel armhf mips64el ppc64el riscv64 s390x
Multi-Arch: same
Depends: ${misc:Depends}, libfalcosecurity0t64 (= ${binary:Version})
Description: Core libraries for Falco and Sysdig
 Sysdig instruments your physical and virtual machines at the OS level
 by installing into the Linux kernel and capturing system calls and
 other OS events. Then, using sysdig's command line interface, you can
 filter and decode these events in order to extract useful information
 and statistics.
 .
 This package contains the build-time libraries to read the events from the
 driver.

Package: falcosecurity-scap-dkms
Section: kernel
Architecture: all
Depends: ${misc:Depends}
Recommends: sysdig
Description: Kernel driver for Falco and Sysdig
 Sysdig instruments your physical and virtual machines at the OS level
 by installing into the Linux kernel and capturing system calls and
 other OS events. Then, using sysdig's command line interface, you can
 filter and decode these events in order to extract useful information
 and statistics.
 .
 This package contains the sources for the kernel driver used by Falco and
 Sysdig to collect data
